Index: trunk/source/Lib/TLibEncoder/TEncCfg.h
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 130)
+++ trunk/source/Lib/TLibEncoder/TEncCfg.h	(revision 189)
@@ -167,4 +167,7 @@
 #endif
   Bool      m_bUseSAO;
+#if LGE_ILLUCOMP_B0045
+  Bool      m_bUseIC;
+#endif
 #if SAO_UNIT_INTERLEAVING
   Int       m_maxNumOffsetsPerPic;
@@ -246,4 +249,8 @@
 #if HHI_MPI
   Bool      m_bUseMVI;
+#endif
+#if RWTH_SDC_DLT_B0036
+  Bool      m_bUseDLT;
+  Bool      m_bUseSDC;
 #endif
 
@@ -272,8 +279,4 @@
   Int       m_iColumnRowInfoPresent;
   Int       m_iUniformSpacingIdr;
-#if FIX_REMOVE_TILE_DEPENDENCE
-#else
-  Int       m_iTileBoundaryIndependenceIdr;
-#endif
   Int       m_iNumColumnsMinus1;
   UInt*     m_puiColumnWidth;
@@ -321,6 +324,6 @@
 #endif
 
-#if OL_DEPTHLIMIT_A0044
-  Bool     m_bDepthPartitionLimiting;
+#if OL_QTLIMIT_PREDCODING_B0068
+  Bool     m_bUseQTLPC;
 #endif
 
@@ -688,6 +691,14 @@
   Void  setUseMVI                      ( Bool bVal )   {m_bUseMVI = bVal;}
 #endif
+#if RWTH_SDC_DLT_B0036
+  Void  setUseDLT                       ( Bool  b )     { m_bUseDLT   = b; }
+  Void  setUseSDC                       ( Bool  b )     { m_bUseSDC   = b; }
+#endif
   Void  setUseSAO                      ( Bool bVal )   {m_bUseSAO = bVal;}
   Bool  getUseSAO                      ()              {return m_bUseSAO;}
+#if LGE_ILLUCOMP_B0045
+  Void  setUseIC                       ( Bool bVal )   {m_bUseIC = bVal;}
+  Bool  getUseIC                       ()              {return m_bUseIC;}
+#endif
 #if SAO_UNIT_INTERLEAVING
   Void  setMaxNumOffsetsPerPic                   (Int iVal)            { m_maxNumOffsetsPerPic = iVal; }
@@ -824,7 +835,12 @@
 #endif
 
-#if OL_DEPTHLIMIT_A0044
-  Void      setUseDPL(Bool b) {m_bDepthPartitionLimiting = b; }
-  Bool      getUseDPL()       {return m_bDepthPartitionLimiting;}
+#if OL_QTLIMIT_PREDCODING_B0068
+  Void      setUseQTLPC( Bool b ) { m_bUseQTLPC = b;    }
+  Bool      getUseQTLPC()         { return m_bUseQTLPC; }
+#endif
+  
+#if RWTH_SDC_DLT_B0036
+  Bool      getUseDLT()      { return m_bUseDLT;     }
+  Bool      getUseSDC()      { return m_bUseSDC;     }
 #endif
 
Index: trunk/source/Lib/TLibEncoder/TEncCu.cpp
===================================================================
--- trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 130)
+++ trunk/source/Lib/TLibEncoder/TEncCu.cpp	(revision 189)
@@ -451,34 +451,15 @@
   TComPic* pcPic = rpcBestCU->getPic();
 
-#if OL_DEPTHLIMIT_A0044
-  TComSPS *sps = pcPic->getSlice(0)->getSPS();
-  TComPic *pcTexture;
-  TComDataCU * pcTextureCU;
-  Bool  depthMapDetect =  false;
-  UInt         uiPrevTexPartIndex = 0;
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-  Bool bIntraSliceDetect = false;
-#endif
-  Bool bTry2NxN = false;
-  Bool bTryNx2N = false;
-    pcTexture = rpcBestCU->getSlice()->getTexturePic();
-    if(pcTexture != NULL) //depth map being encoded
-    {
-    depthMapDetect = true;
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-      bIntraSliceDetect = (rpcBestCU->getSlice()->getSliceType()==I_SLICE);
-#endif
-    if(uiDepth == 0)
-    {
-      pcTextureCU = pcTexture->getCU( rpcBestCU->getAddr() );
-      pcTexture->setPartInfo(pcTextureCU->readPartInfo());
-      pcTexture->setTexPartIndex(0); 
-    }
-    }
-    else
-    {
-      depthMapDetect = false;
-    }
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068
+  TComSPS *sps         = pcPic->getSlice(0)->getSPS();
+  TComPic *pcTexture   = rpcBestCU->getSlice()->getTexturePic();
+
+  Bool  depthMapDetect    = (pcTexture != NULL);
+  Bool  bIntraSliceDetect = (rpcBestCU->getSlice()->getSliceType() == I_SLICE);
+
+  Bool bTry2NxN = true;
+  Bool bTryNx2N = true;
+#endif
+
   // get Original YUV data from picture
   m_ppcOrigYuv[uiDepth]->copyFromPicYuv( pcPic->getPicYuvOrg(), rpcBestCU->getAddr(), rpcBestCU->getZorderIdxInCU() );
@@ -511,4 +492,10 @@
   UInt uiTPelY   = rpcBestCU->getCUPelY();
   UInt uiBPelY   = uiTPelY + rpcBestCU->getHeight(0) - 1;
+
+#if LGE_ILLUCOMP_B0045
+  Bool bICEnabled = (!rpcTempCU->getSlice()->getIsDepth() && rpcTempCU->getSlice()->getViewId());
+
+  bICEnabled = bICEnabled && rpcTempCU->getSlice()->getApplyIC();
+#endif
 
 #if HHI_INTERVIEW_SKIP
@@ -618,82 +605,30 @@
       // variables for fast encoder decision
       bEarlySkip  = false;
-      bTrySplit    = true;
+      bTrySplit   = true;
       fRD_Skip    = MAX_DOUBLE;
 
       rpcTempCU->initEstData( uiDepth, iQP );
 
-#if OL_DEPTHLIMIT_A0044
+#if OL_QTLIMIT_PREDCODING_B0068
       //logic for setting bTrySplit using the partition information that is stored of the texture colocated CU
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-      if(depthMapDetect && !bIntraSliceDetect && sps->getUseDPL())
-#else
-      if(depthMapDetect && sps->getUseDPL()) //depth map being encoded
-#endif
-      {
-        assert(uiDepth == pcTexture->accessPartInfo(1));
-        if(pcTexture->accessPartInfo(0) == 1) //NxN modes
+      if(depthMapDetect && !bIntraSliceDetect && sps->getUseQTLPC())
+      {
+        TComDataCU* pcTextureCU = pcTexture->getCU( rpcBestCU->getAddr() ); //Corresponding texture LCU
+        UInt uiCUIdx            = rpcBestCU->getZorderIdxInCU();
+        assert(pcTextureCU->getDepth(uiCUIdx) >= uiDepth); //Depth cannot be more partitionned than the texture.
+        if (pcTextureCU->getDepth(uiCUIdx) > uiDepth || pcTextureCU->getPartitionSize(uiCUIdx) == SIZE_NxN) //Texture was split.
         {
           bTrySplit = true;
-          bTryNx2N = true;
-          bTry2NxN = true;
-          uiPrevTexPartIndex = pcTexture->getTexPartIndex(); 
-          pcTexture->incrementTexPartIndex(); 
+          bTryNx2N  = true;
+          bTry2NxN  = true;
         }
-        else if(pcTexture->accessPartInfo(0) == 0) //2Nx2N modes
-        {
-          UInt uiTexdepth;
-          UInt temp_uiTexPartIndex;
-          bTrySplit = false;
-
-          //scan ahead till next depth
-          uiTexdepth = pcTexture->accessPartInfo(1);
-          uiPrevTexPartIndex = pcTexture->getTexPartIndex(); 
-          pcTexture->incrementTexPartIndex();
-          temp_uiTexPartIndex = pcTexture->getTexPartIndex(); //store in case to rewind
-
-          while(uiTexdepth != pcTexture->accessPartInfo(1) && uiTexdepth != 0)
-          {
-            if(pcTexture->accessPartInfo(1) < uiTexdepth)
-            {
-              break;
-            }
-            pcTexture->incrementTexPartIndex(); 
-
-            if(pcTexture->accessPartInfo(1) == OL_END_CU)
-            {
-              pcTexture->setTexPartIndex(temp_uiTexPartIndex); 
-              uiTexdepth++;
-              if(uiTexdepth >= g_uiMaxCUDepth)
-              {      
-                break;
-              }
-            }
-          }
-        }
-        else if(pcTexture->accessPartInfo(0) == OL_END_CU)
+        else
         {
           bTrySplit = false;
-          bTryNx2N = false;
-          bTry2NxN = false;
+          bTryNx2N  = false;
+          bTry2NxN  = false;
         }
-        else if(pcTexture->accessPartInfo(0) == 2) //2NxN case
-        {
-          bTrySplit = false;
-          bTryNx2N = false;
-          bTry2NxN = true;
-          uiPrevTexPartIndex = pcTexture->getTexPartIndex();  
-          pcTexture->incrementTexPartIndex(); ;
-        }
-        else if(pcTexture->accessPartInfo(0) == 3) //Nx2N case
-        {
-          bTrySplit = false;
-          bTryNx2N = true;
-          bTry2NxN = false;
-          uiPrevTexPartIndex = pcTexture->getTexPartIndex();  
-          pcTexture->incrementTexPartIndex(); ;
-        }
-      }
-#endif
-
+      }
+#endif
 
       // do inter modes, SKIP and 2Nx2N
@@ -718,4 +653,10 @@
         {
           Bool bResPredFlag  = ( uiResPrdId > 0 );
+#if LGE_ILLUCOMP_B0045
+          for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
+          {
+            Bool bICFlag = (uiICId ? true : false);
+            rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+#endif
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -740,5 +681,11 @@
             }
           }
-
+#if LGE_ILLUCOMP_B0045_ENCSIMP
+          if(bICFlag && rpcBestCU->getMergeFlag(0) && !rpcBestCU->getICFlag(0))
+          {
+             bICEnabled = false;
+             break;
+          }
+#endif
           // 2Nx2N, NxN
           if ( !bEarlySkip )
@@ -759,4 +706,7 @@
             }
           }
+#if LGE_ILLUCOMP_B0045
+         }
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
         } // uiResPrdId
@@ -764,10 +714,10 @@
       } // != I_SLICE
 
-#if OL_DEPTHLIMIT_A0044
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-      if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-      if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if LGE_ILLUCOMP_B0045_ENCSIMP
+    bICEnabled = rpcBestCU->getICFlag(0);
+#endif
+
+#if OL_QTLIMIT_PREDCODING_B0068
+      if(depthMapDetect && !bIntraSliceDetect  && sps->getUseQTLPC())
       {
         bTrySplitDQP = bTrySplit;
@@ -775,4 +725,5 @@
       else
       {
+#endif
         if( (g_uiMaxCUWidth>>uiDepth) >= rpcTempCU->getSlice()->getPPS()->getMinCuDQPSize() )
         {
@@ -786,19 +737,8 @@
           bTrySplitDQP = bTrySplit;
         }
-      }
-#else
-
-      if( (g_uiMaxCUWidth>>uiDepth) >= rpcTempCU->getSlice()->getPPS()->getMinCuDQPSize() )
-      {
-        if(iQP == iBaseQP)
-        {
-          bTrySplitDQP = bTrySplit;
-        }
-      }
-      else
-      {
-        bTrySplitDQP = bTrySplit;
-      }
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068
+      }
+#endif
+
 #if LOSSLESS_CODING
       if (isAddLowestQP && (iQP == lowestQP))
@@ -841,4 +781,10 @@
         {
           Bool bResPredFlag  = ( uiResPrdId > 0 );
+#if LGE_ILLUCOMP_B0045
+          for(UInt uiICId = 0; uiICId < (bICEnabled ? 2 : 1); uiICId++)
+          {
+            Bool bICFlag = (uiICId ? true : false);
+            rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uiDepth);
+#endif
 #endif
           // 2Nx2N, NxN
@@ -850,28 +796,8 @@
               if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth && doNotBlockPu)
               {
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-                if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-                if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try InterNxN
+                if(bTrySplit)
                 {
-                  if (bTrySplit)
-                  {
-#endif
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_NxN, bFullyRenderedSec   );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_NxN   );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-#if OL_DEPTHLIMIT_A0044
-                  }//bTrySplit
-                }//depthMapDetect
-                else//do things normally
-                {
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
                   rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
@@ -883,4 +809,5 @@
 #endif
                   rpcTempCU->initEstData( uiDepth, iQP );
+#if OL_QTLIMIT_PREDCODING_B0068
                 }
 #endif
@@ -890,35 +817,8 @@
 
           { // 2NxN, Nx2N
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-            if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-            if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try Nx2N
+            if(bTryNx2N)
             {
-              if (bTryNx2N)
-              {
-#endif
-                if(doNotBlockPu)
-                {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                  rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                  xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_Nx2N, bFullyRenderedSec   );
-#else
-                  xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_Nx2N  );
-#endif
-                  rpcTempCU->initEstData( uiDepth, iQP );
-                  if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_Nx2N )
-                  {
-                    doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                  }
-                }
-#if OL_DEPTHLIMIT_A0044
-              }//bTryNx2N
-            }//depthMapDetect
-            else//do things normally
-            {
+#endif
               if(doNotBlockPu)
               {
@@ -937,38 +837,12 @@
                 }
               }
+#if OL_QTLIMIT_PREDCODING_B0068
             }
 #endif
 
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-            if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-            if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try 2NxN
+            if(bTry2NxN)
             {
-              if (bTry2NxN)
-              {
-#endif
-                if(doNotBlockPu)
-                {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                  rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                  xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxN, bFullyRenderedSec   );
-#else
-                  xCheckRDCostInter      ( rpcBestCU, rpcTempCU, SIZE_2NxN  );
-#endif
-                  rpcTempCU->initEstData( uiDepth, iQP );
-                  if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_2NxN)
-                  {
-                    doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                  }
-                }
-#if OL_DEPTHLIMIT_A0044
-              }//bTryNx2N
-            }//depthMapDetect
-            else//do things normally
-            {
+#endif
               if(doNotBlockPu)
               {
@@ -987,4 +861,5 @@
                 }
               }
+#if OL_QTLIMIT_PREDCODING_B0068
             }
 #endif
@@ -1009,51 +884,8 @@
             if ( bTestAMP_Hor )
             {
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-              if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-              if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try 2NxnU & 2NxnD
+              if(bTry2NxN)
               {
-                if (bTry2NxN)
-                {
-#endif
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnU, bFullyRenderedSec );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnU );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                    if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_2NxnU )
-                    {
-                      doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                    }
-                  }
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnD, bFullyRenderedSec );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnD );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                    if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_2NxnD )
-                    {
-                      doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                    }
-                  }
-#if OL_DEPTHLIMIT_A0044
-                }//bTry2NxN
-              }//depthMapDetect
-              else//do things normally
-              {
+#endif
                 if(doNotBlockPu)
                 {
@@ -1088,4 +920,5 @@
                   }
                 }
+#if OL_QTLIMIT_PREDCODING_B0068
               }
 #endif
@@ -1094,51 +927,8 @@
             else if ( bTestMergeAMP_Hor ) 
             {
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-              if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-              if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try 2NxnU & 2NxnD Merge
+              if(bTry2NxN)
               {
-                if (bTry2NxN)
-                {
-#endif
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnU, bFullyRenderedSec, true );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnU, true );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                    if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_2NxnU )
-                    {
-                      doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                    }
-                  }
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnD, bFullyRenderedSec, true );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_2NxnD, true );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                    if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_2NxnD )
-                    {
-                      doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                    }
-                  }
-#if OL_DEPTHLIMIT_A0044
-                }//bTry2NxN
-              }//depthMapDetect
-              else//do things normally
-              {
+#endif
                 if(doNotBlockPu)
                 {
@@ -1173,5 +963,5 @@
                   }
                 }
-
+#if OL_QTLIMIT_PREDCODING_B0068
               }
 #endif
@@ -1182,47 +972,8 @@
             if ( bTestAMP_Ver )
             {
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-              if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-              if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try nLx2N & nRx2N
+              if(bTryNx2N)
               {
-                if (bTryNx2N)
-                {
-#endif
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nLx2N, bFullyRenderedSec );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nLx2N );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                    if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_nLx2N )
-                    {
-                      doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                    }
-                  }
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nRx2N, bFullyRenderedSec );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nRx2N );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                  }
-#if OL_DEPTHLIMIT_A0044
-                }//bTryNx2N
-              }//depthMapDetect
-              else//do things normally
-              {
+#endif
                 if(doNotBlockPu)
                 {
@@ -1253,4 +1004,5 @@
                   rpcTempCU->initEstData( uiDepth, iQP );
                 }
+#if OL_QTLIMIT_PREDCODING_B0068
               }
 #endif
@@ -1259,47 +1011,8 @@
             else if ( bTestMergeAMP_Ver )
             {
-#if OL_DEPTHLIMIT_A0044 //add code here to select 2NxN or Nx2N or none
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-              if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-              if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //try nLx2N & nRx2N (Merge)
+              if(bTryNx2N)
               {
-                if (bTryNx2N)
-                {
-#endif
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nLx2N, bFullyRenderedSec, true );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nLx2N, true );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                    if(m_pcEncCfg->getUseCbfFastMode() && rpcBestCU->getPartitionSize(0) == SIZE_nLx2N )
-                    {
-                      doNotBlockPu = rpcBestCU->getQtRootCbf( 0 ) != 0;
-                    }
-                  }
-                  if(doNotBlockPu)
-                  {
-#if HHI_INTER_VIEW_RESIDUAL_PRED
-                    rpcTempCU->setResPredIndicator( bResPredAvailable, bResPredFlag );
-#endif
-#if HHI_INTERVIEW_SKIP
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nRx2N, bFullyRenderedSec, true );
-#else
-                    xCheckRDCostInter( rpcBestCU, rpcTempCU, SIZE_nRx2N, true );
-#endif
-                    rpcTempCU->initEstData( uiDepth, iQP );
-                  }
-#if OL_DEPTHLIMIT_A0044
-                }//bTryNx2N
-              }//depthMapDetect
-              else//do things normally
-              {
+#endif
                 if(doNotBlockPu)
                 {
@@ -1330,4 +1043,5 @@
                   rpcTempCU->initEstData( uiDepth, iQP );
                 }
+#if OL_QTLIMIT_PREDCODING_B0068
               }
 #endif
@@ -1375,4 +1089,7 @@
 #endif
           } //! Try AMP (SIZE_2NxnU, SIZE_2NxnD, SIZE_nLx2N, SIZE_nRx2N)
+#endif
+#if LGE_ILLUCOMP_B0045
+         }
 #endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
@@ -1401,34 +1118,24 @@
 #endif
         {
+#if LGE_ILLUCOMP_B0045
+          rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
+#endif
           xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_2Nx2N );
           rpcTempCU->initEstData( uiDepth, iQP );
           if( uiDepth == g_uiMaxCUDepth - g_uiAddCUDepth )
           {
-#if OL_DEPTHLIMIT_A0044 //add code here to select or deselect NxN mode for Intra
-#if OL_DO_NOT_LIMIT_INTRA_SLICES_PART
-            if(depthMapDetect && !bIntraSliceDetect  && sps->getUseDPL())
-#else
-            if(depthMapDetect  && sps->getUseDPL()) //depth map being encoded
-#endif
+#if OL_QTLIMIT_PREDCODING_B0068 //Try IntraNxN
+            if(bTrySplit)
             {
-              if (bTrySplit)
-              {
-
-#endif
-                if( rpcTempCU->getWidth(0) > ( 1 << rpcTempCU->getSlice()->getSPS()->getQuadtreeTULog2MinSize() ) )
-                {
-                  xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN   );
-                  rpcTempCU->initEstData( uiDepth, iQP );
-                }
-#if OL_DEPTHLIMIT_A0044
-              }//bTrySplit
-            }//depthMapDetect
-            else
-            {
+#endif
               if( rpcTempCU->getWidth(0) > ( 1 << rpcTempCU->getSlice()->getSPS()->getQuadtreeTULog2MinSize() ) )
               {
+#if LGE_ILLUCOMP_B0045
+                rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
+#endif
                 xCheckRDCostIntra( rpcBestCU, rpcTempCU, SIZE_NxN   );
                 rpcTempCU->initEstData( uiDepth, iQP );
               }
+#if OL_QTLIMIT_PREDCODING_B0068
             }
 #endif
@@ -1451,4 +1158,7 @@
 #endif
         {
+#if LGE_ILLUCOMP_B0045
+          rpcTempCU->setICFlagSubParts(false, 0, 0, uiDepth);
+#endif
           xCheckIntraPCM (rpcBestCU, rpcTempCU);
           rpcTempCU->initEstData( uiDepth, iQP );
@@ -1638,15 +1348,4 @@
 
 #if HHI_VSO
-#if HHI_VSO_SET_OPTIM 
-#else 
-          if( m_pcRdCost->getUseRenModel() ) // necessary ??
-          {
-            UInt  uiWidth     = m_ppcRecoYuvBest[uhNextDepth]->getWidth   (  );
-            UInt  uiHeight    = m_ppcRecoYuvBest[uhNextDepth]->getHeight  (   );
-            Pel*  piSrc       = m_ppcRecoYuvBest[uhNextDepth]->getLumaAddr( 0 );
-            UInt  uiSrcStride = m_ppcRecoYuvBest[uhNextDepth]->getStride  (   );
-            m_pcRdCost->setRenModelData( pcSubBestPartCU, 0, piSrc, uiSrcStride, uiWidth, uiHeight );
-          }
-#endif
 #endif
         }
@@ -2086,12 +1785,8 @@
   if( pcCU->isSkipped( uiAbsPartIdx ) )
   {
-#if OL_DEPTHLIMIT_A0044
-    if(pcCU->getPartDumpFlag())
-    {
-      pcCU->updatePartInfo(0,uiDepth);
-      pcCU->incrementPartInfo();
-    }
-#endif
     m_pcEntropyCoder->encodeMergeIndex( pcCU, uiAbsPartIdx, 0 );
+#if LGE_ILLUCOMP_B0045
+    m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
     m_pcEntropyCoder->encodeResPredFlag( pcCU, uiAbsPartIdx, 0 );
@@ -2122,4 +1817,7 @@
   // prediction Info ( Intra : direction mode, Inter : Mv, reference idx )
   m_pcEntropyCoder->encodePredInfo( pcCU, uiAbsPartIdx );
+#if LGE_ILLUCOMP_B0045
+    m_pcEntropyCoder->encodeICFlag  ( pcCU, uiAbsPartIdx );
+#endif
 #if HHI_INTER_VIEW_RESIDUAL_PRED
     if( !pcCU->isIntra( uiAbsPartIdx ) )
@@ -2165,4 +1863,7 @@
   Bool  bResPrdAvail  = rpcTempCU->getResPredAvail( 0 );
   Bool  bResPrdFlag   = rpcTempCU->getResPredFlag ( 0 );
+#endif
+#if LGE_ILLUCOMP_B0045
+  Bool  bICFlag = rpcTempCU->getICFlag(0);
 #endif
 
@@ -2240,11 +1941,15 @@
           rpcTempCU->setResPredFlagSubParts ( bResPrdFlag,  0, 0, uhDepth );
 #endif
+#if LGE_ILLUCOMP_B0045
+          rpcTempCU->setICFlagSubParts(bICFlag, 0, 0, uhDepth);
+#endif
 
           // do MC
 #if HHI_INTERVIEW_SKIP
-      if ( (uiNoResidual == 0) || bSkipRes ){
-#else
-      if ( uiNoResidual == 0 ){
-#endif
+      if ( (uiNoResidual == 0) || bSkipRes )
+#else
+      if ( uiNoResidual == 0 )
+#endif
+        {
             m_pcPredSearch->motionCompensation ( rpcTempCU, m_ppcPredYuvTemp[uhDepth] );
             // save pred adress
@@ -2476,4 +2181,7 @@
   m_ppcRecoYuvTemp[uiDepth]->copyToPicLuma(rpcTempCU->getPic()->getPicYuvRec(), rpcTempCU->getAddr(), rpcTempCU->getZorderIdxInCU() );
   
+#if RWTH_SDC_DLT_B0036
+  if( !rpcTempCU->getSDCFlag( 0 ) )
+#endif
   m_pcPredSearch  ->estIntraPredChromaQT( rpcTempCU, m_ppcOrigYuv[uiDepth], m_ppcPredYuvTemp[uiDepth], m_ppcResiYuvTemp[uiDepth], m_ppcRecoYuvTemp[uiDepth], uiPreCalcDistC );
   
@@ -2944,4 +2652,5 @@
   assert( bRecursiveCall == ( uhDepth != uhTextureModeDepth ) );
 
+#if !MTK_UNCONSTRAINED_MVI_B0083
   if( uhDepth == uhTextureModeDepth )
   {
@@ -2954,4 +2663,5 @@
     }
   }
+#endif
 
 #if HHI_VSO
@@ -3059,5 +2769,18 @@
     rpcTempCU->setTextureModeDepthSubParts( uhTextureModeDepth, 0, uhDepth );
     rpcTempCU->copyTextureMotionDataFrom( pcTextureCU, uhDepth, rpcTempCU->getZorderIdxInCU() );
+#if FIX_MPI_B0065
+    UInt uiAbsPartIdx = rpcTempCU->getZorderIdxInCU();
+    if( rpcTempCU->getDepth(0) > pcTextureCU->getDepth(uiAbsPartIdx))
+    {
+      rpcTempCU->setPartSizeSubParts( SIZE_NxN, 0, uhDepth );
+    }
+    else
+    {
+      PartSize partSize = pcTextureCU->getPartitionSize(uiAbsPartIdx);
+      rpcTempCU->setPartSizeSubParts( partSize, 0, uhDepth );
+    }
+#else
     rpcTempCU->setPartSizeSubParts( SIZE_NxN, 0, uhDepth );
+#endif
     for( UInt ui = 0; ui < rpcTempCU->getTotalNumPart(); ui++ )
     {
@@ -3152,4 +2875,7 @@
   {
     m_pcEntropyCoder->encodeMergeIndex( pcCU, 0, 0, true );
+#if LGE_ILLUCOMP_B0045
+    m_pcEntropyCoder->encodeICFlag( pcCU, 0, true );
+#endif
   }
   else
@@ -3159,4 +2885,7 @@
     // prediction Info ( Intra : direction mode, Inter : Mv, reference idx )
     m_pcEntropyCoder->encodePredInfo( pcCU, 0, true );
+#if LGE_ILLUCOMP_B0045
+    m_pcEntropyCoder->encodeICFlag( pcCU, 0,          true );
+#endif
   }
   xRestoreDepthWidthHeight( pcCU );
